"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Checkbox = void 0;
/** @jsxRuntime classic */
/** @jsx withSlots */
var React = __importStar(require("react"));
var react_native_1 = require("react-native");
var framework_1 = require("@fluentui-react-native/framework");
var text_1 = require("@fluentui-react-native/text");
var react_native_svg_1 = require("react-native-svg");
var Checkbox_styling_1 = require("./Checkbox.styling");
var Checkbox_types_1 = require("./Checkbox.types");
var useCheckbox_1 = require("./useCheckbox");
exports.Checkbox = (0, framework_1.compose)(__assign(__assign({ displayName: Checkbox_types_1.checkboxName }, Checkbox_styling_1.stylingSettings), { slots: {
        root: react_native_1.Pressable,
        checkbox: react_native_1.Pressable,
        checkmark: react_native_svg_1.Svg,
        label: text_1.TextV1,
        required: text_1.TextV1,
    }, useRender: function (userProps, useSlots) {
        // configure props and state for checkbox based on user props
        var Checkbox = (0, useCheckbox_1.useCheckbox)(userProps);
        // grab the styled slots
        var Slots = useSlots(userProps, function (layer) {
            return Checkbox.state[layer] ||
                userProps[layer] ||
                layer === userProps['shape'] ||
                layer === userProps['size'] ||
                (!userProps['size'] && layer === (0, Checkbox_styling_1.getDefaultSize)());
        });
        // now return the handler for finishing render
        return function (final) {
            var _a = (0, framework_1.mergeProps)(Checkbox.props, final), label = _a.label, required = _a.required, mergedProps = __rest(_a, ["label", "required"]);
            var onPress = mergedProps.onPress, disabled = mergedProps.disabled;
            var labelComponent = ((0, framework_1.withSlots)(React.Fragment, null,
                (0, framework_1.withSlots)(Slots.label, { key: "label" }, label),
                !!required && (0, framework_1.withSlots)(Slots.required, null, typeof required === 'string' ? required : '*')));
            // We want a thicker checkmark in HC to make the checkmark stand out more.
            var checkmarkPath = ((0, framework_1.withSlots)(react_native_svg_1.Path, { fill: "currentColor", d: "M9.76497 3.20474C10.0661 3.48915 10.0797 3.96383 9.79526 4.26497L5.54526 8.76497C5.40613 8.91228 5.21332 8.99703 5.01071 8.99993C4.8081 9.00282 4.61295 8.92361 4.46967 8.78033L2.21967 6.53033C1.92678 6.23744 1.92678 5.76257 2.21967 5.46967C2.51256 5.17678 2.98744 5.17678 3.28033 5.46967L4.98463 7.17397L8.70474 3.23503C8.98915 2.9339 9.46383 2.92033 9.76497 3.20474Z" }));
            return ((0, framework_1.withSlots)(Slots.root, __assign({}, mergedProps, (react_native_1.Platform.OS == 'android' && { accessible: !disabled, focusable: !disabled })),
                Checkbox.state.labelIsBefore && labelComponent,
                (0, framework_1.withSlots)(Slots.checkbox, { accessible: false, onPress: onPress, disabled: disabled, focusable: false },
                    (0, framework_1.withSlots)(Slots.checkmark, { key: "checkmark", viewBox: "0 0 12 12" }, checkmarkPath)),
                !Checkbox.state.labelIsBefore && labelComponent));
        };
    } }));
exports.default = exports.Checkbox;
//# sourceMappingURL=Checkbox.js.map