"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDefaultSize = exports.stylingSettings = exports.checkboxStates = void 0;
var react_native_1 = require("react-native");
var framework_1 = require("@fluentui-react-native/framework");
var styling_utils_1 = require("@fluentui-react-native/styling-utils");
var tokens_1 = require("@fluentui-react-native/tokens");
var Checkbox_types_1 = require("./Checkbox.types");
var CheckboxTokens_1 = require("./CheckboxTokens");
exports.checkboxStates = [
    'medium',
    'large',
    'circular',
    'label',
    'labelIsBefore',
    'hovered',
    'focused',
    'pressed',
    'checked',
    'disabled',
];
var hasPresetRententionForA11y = react_native_1.Platform.OS === 'android';
exports.stylingSettings = {
    tokens: [CheckboxTokens_1.defaultCheckboxTokens, Checkbox_types_1.checkboxName],
    states: exports.checkboxStates,
    slotProps: {
        root: (0, framework_1.buildProps)(function (tokens, theme) { return ({
            style: __assign({ display: 'flex', alignItems: 'center', flexDirection: 'row', alignSelf: 'flex-start', backgroundColor: tokens.backgroundColor, padding: tokens.padding, paddingHorizontal: tokens.paddingHorizontal }, tokens_1.borderStyles.from(tokens, theme)),
            android_ripple: { color: tokens.rippleColor, foreground: true },
        }); }, __spreadArray(__spreadArray(['backgroundColor', 'padding'], tokens_1.borderStyles.keys, true), ['rippleColor'], false)),
        label: (0, framework_1.buildProps)(function (tokens, theme) { return ({
            style: contentStyling(tokens, theme),
        }); }, __spreadArray(['spacingLabelAfter', 'spacingLabelBefore', 'color'], tokens_1.fontStyles.keys, true)),
        checkbox: (0, framework_1.buildProps)(function (tokens) { return (__assign(__assign({ style: {
                height: tokens.checkboxSize,
                width: tokens.checkboxSize,
                backgroundColor: tokens.checkboxBackgroundColor,
                borderColor: tokens.checkboxBorderColor,
                borderRadius: tokens.checkboxBorderRadius,
                borderWidth: tokens.checkboxBorderWidth,
                alignItems: 'center',
                justifyContent: 'center',
            } }, (hasPresetRententionForA11y && {
            pressRetentionOffset: typeof tokens.padding === 'number' ? tokens.padding : typeof tokens.padding === 'string' ? parseFloat(tokens.padding) : 0, /// Retention of the press area outside of the checkbox equal to padding to match accessibility requirement
        })), { android_ripple: { color: tokens.rippleColor, radius: tokens.checkmarkSize, foreground: true } })); }, ['checkboxBackgroundColor', 'checkboxBorderColor', 'checkboxBorderRadius', 'checkboxBorderWidth', 'checkboxSize', 'rippleColor']),
        checkmark: (0, framework_1.buildProps)(function (tokens) { return ({
            style: {
                width: tokens.checkmarkSize,
                height: tokens.checkmarkSize,
                color: tokens.checkmarkColor,
                opacity: tokens.checkmarkOpacity,
            },
        }); }, ['checkmarkColor', 'checkmarkSize', 'checkmarkOpacity']),
        required: (0, framework_1.buildProps)(function (tokens, theme) { return ({
            style: __assign({ color: tokens.requiredColor, paddingStart: tokens.requiredPadding }, tokens_1.fontStyles.from(tokens, theme)),
        }); }, __spreadArray(['requiredColor', 'requiredPadding'], tokens_1.fontStyles.keys, true)),
    },
};
var getDefaultSize = function () {
    return 'medium';
};
exports.getDefaultSize = getDefaultSize;
var contentStyling = function (tokens, theme) {
    var textAdjustment = (0, styling_utils_1.getTextMarginAdjustment)();
    var spacingLabelAfter = tokens.spacingLabelAfter
        ? {
            marginStart: textAdjustment.marginStart + tokens.spacingLabelAfter,
        }
        : {};
    var spacingLabelBefore = tokens.spacingLabelBefore
        ? {
            marginEnd: textAdjustment.marginEnd + tokens.spacingLabelBefore,
        }
        : {};
    return __assign(__assign(__assign({ color: tokens.color }, spacingLabelBefore), spacingLabelAfter), tokens_1.fontStyles.from(tokens, theme));
};
//# sourceMappingURL=Checkbox.styling.js.map