"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCheckbox = void 0;
var React = __importStar(require("react"));
var framework_1 = require("@fluentui-react-native/framework");
var interactive_hooks_1 = require("@fluentui-react-native/interactive-hooks");
var defaultAccessibilityActions = [{ name: 'Toggle' }];
/**
 * Re-usable hook for FURN Checkbox.
 * This hook configures checkbox props and state for FURN Checkbox.
 *
 * @param props user props sent to FURN Checkbox
 * @returns configured props and state for FURN Checkbox
 */
var useCheckbox = function (props) {
    var defaultComponentRef = React.useRef(null);
    var accessible = props.accessible, accessibilityActions = props.accessibilityActions, accessibilityLabel = props.accessibilityLabel, accessibilityRole = props.accessibilityRole, accessibilityState = props.accessibilityState, _a = props.componentRef, componentRef = _a === void 0 ? defaultComponentRef : _a, checked = props.checked, defaultChecked = props.defaultChecked, enableFocusRing = props.enableFocusRing, focusable = props.focusable, labelPosition = props.labelPosition, label = props.label, onAccessibilityAction = props.onAccessibilityAction, onChange = props.onChange, required = props.required, rest = __rest(props, ["accessible", "accessibilityActions", "accessibilityLabel", "accessibilityRole", "accessibilityState", "componentRef", "checked", "defaultChecked", "enableFocusRing", "focusable", "labelPosition", "label", "onAccessibilityAction", "onChange", "required"]);
    // Warns defaultChecked and checked being mutually exclusive.
    if (defaultChecked != undefined && checked != undefined) {
        console.warn('defaultChecked and checked are mutually exclusive to one another. Use one or the other.');
    }
    // Re-usable hook for toggle components.
    var _b = (0, interactive_hooks_1.useAsToggleWithEvent)(defaultChecked, checked, onChange), isChecked = _b[0], toggleChecked = _b[1];
    // Ensure focus is placed on checkbox after click
    var toggleCheckedWithFocus = (0, interactive_hooks_1.useOnPressWithFocus)(componentRef, toggleChecked);
    // attach the pressable state handlers
    var pressable = (0, interactive_hooks_1.usePressableState)(__assign({ onPress: toggleCheckedWithFocus }, rest));
    var buttonRef = (0, interactive_hooks_1.useViewCommandFocus)(componentRef);
    // Handles the "Space" key toggling the Checkbox
    var onKeyUpProps = (0, interactive_hooks_1.useKeyProps)(toggleChecked, ' ');
    var accessibilityActionsProp = accessibilityActions
        ? __spreadArray(__spreadArray([], defaultAccessibilityActions, true), accessibilityActions, true) : defaultAccessibilityActions;
    var state = __assign(__assign({}, pressable.state), { disabled: !!props.disabled, checked: isChecked, labelIsBefore: labelPosition === 'before' ? true : false });
    var onAccessibilityActionProp = React.useCallback(function (event) {
        switch (event.nativeEvent.actionName) {
            case 'Toggle':
                toggleChecked(event);
                break;
        }
        onAccessibilityAction && onAccessibilityAction(event);
    }, [toggleChecked, onAccessibilityAction]);
    return {
        props: __assign(__assign(__assign(__assign({ ref: buttonRef }, pressable.props), { accessible: accessible !== null && accessible !== void 0 ? accessible : true, accessibilityRole: accessibilityRole !== null && accessibilityRole !== void 0 ? accessibilityRole : 'checkbox', accessibilityLabel: accessibilityLabel !== null && accessibilityLabel !== void 0 ? accessibilityLabel : label, accessibilityState: getAccessibilityState(state.disabled, state.checked, !!required, accessibilityState), accessibilityActions: accessibilityActionsProp, focusable: focusable !== null && focusable !== void 0 ? focusable : !state.disabled, onAccessibilityAction: onAccessibilityActionProp, enableFocusRing: enableFocusRing !== null && enableFocusRing !== void 0 ? enableFocusRing : true }), onKeyUpProps), props),
        state: __assign(__assign({}, pressable.state), state),
    };
};
exports.useCheckbox = useCheckbox;
var getAccessibilityState = (0, framework_1.memoize)(getAccessibilityStateWorker);
function getAccessibilityStateWorker(disabled, checked, required, accessibilityState) {
    checked = checked !== null && checked !== void 0 ? checked : false; // Make the value of checked as false when checked is undefined or null for screen reader to announce 'unchecked'
    if (accessibilityState) {
        return __assign({ disabled: disabled, checked: checked, required: required }, accessibilityState);
    }
    return { disabled: disabled, checked: checked, required: required };
}
//# sourceMappingURL=useCheckbox.js.map