var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { Platform } from 'react-native';
import { buildProps } from '@fluentui-react-native/framework';
import { getTextMarginAdjustment } from '@fluentui-react-native/styling-utils';
import { borderStyles, fontStyles } from '@fluentui-react-native/tokens';
import { checkboxName } from './Checkbox.types';
import { defaultCheckboxTokens } from './CheckboxTokens';
export var checkboxStates = [
    'medium',
    'large',
    'circular',
    'label',
    'labelIsBefore',
    'hovered',
    'focused',
    'pressed',
    'checked',
    'disabled',
];
var hasPresetRententionForA11y = Platform.OS === 'android';
export var stylingSettings = {
    tokens: [defaultCheckboxTokens, checkboxName],
    states: checkboxStates,
    slotProps: {
        root: buildProps(function (tokens, theme) { return ({
            style: __assign({ display: 'flex', alignItems: 'center', flexDirection: 'row', alignSelf: 'flex-start', backgroundColor: tokens.backgroundColor, padding: tokens.padding, paddingHorizontal: tokens.paddingHorizontal }, borderStyles.from(tokens, theme)),
            android_ripple: { color: tokens.rippleColor, foreground: true },
        }); }, __spreadArray(__spreadArray(['backgroundColor', 'padding'], borderStyles.keys, true), ['rippleColor'], false)),
        label: buildProps(function (tokens, theme) { return ({
            style: contentStyling(tokens, theme),
        }); }, __spreadArray(['spacingLabelAfter', 'spacingLabelBefore', 'color'], fontStyles.keys, true)),
        checkbox: buildProps(function (tokens) { return (__assign(__assign({ style: {
                height: tokens.checkboxSize,
                width: tokens.checkboxSize,
                backgroundColor: tokens.checkboxBackgroundColor,
                borderColor: tokens.checkboxBorderColor,
                borderRadius: tokens.checkboxBorderRadius,
                borderWidth: tokens.checkboxBorderWidth,
                alignItems: 'center',
                justifyContent: 'center',
            } }, (hasPresetRententionForA11y && {
            pressRetentionOffset: typeof tokens.padding === 'number' ? tokens.padding : typeof tokens.padding === 'string' ? parseFloat(tokens.padding) : 0, /// Retention of the press area outside of the checkbox equal to padding to match accessibility requirement
        })), { android_ripple: { color: tokens.rippleColor, radius: tokens.checkmarkSize, foreground: true } })); }, ['checkboxBackgroundColor', 'checkboxBorderColor', 'checkboxBorderRadius', 'checkboxBorderWidth', 'checkboxSize', 'rippleColor']),
        checkmark: buildProps(function (tokens) { return ({
            style: {
                width: tokens.checkmarkSize,
                height: tokens.checkmarkSize,
                color: tokens.checkmarkColor,
                opacity: tokens.checkmarkOpacity,
            },
        }); }, ['checkmarkColor', 'checkmarkSize', 'checkmarkOpacity']),
        required: buildProps(function (tokens, theme) { return ({
            style: __assign({ color: tokens.requiredColor, paddingStart: tokens.requiredPadding }, fontStyles.from(tokens, theme)),
        }); }, __spreadArray(['requiredColor', 'requiredPadding'], fontStyles.keys, true)),
    },
};
export var getDefaultSize = function () {
    return 'medium';
};
var contentStyling = function (tokens, theme) {
    var textAdjustment = getTextMarginAdjustment();
    var spacingLabelAfter = tokens.spacingLabelAfter
        ? {
            marginStart: textAdjustment.marginStart + tokens.spacingLabelAfter,
        }
        : {};
    var spacingLabelBefore = tokens.spacingLabelBefore
        ? {
            marginEnd: textAdjustment.marginEnd + tokens.spacingLabelBefore,
        }
        : {};
    return __assign(__assign(__assign({ color: tokens.color }, spacingLabelBefore), spacingLabelAfter), fontStyles.from(tokens, theme));
};
//# sourceMappingURL=Checkbox.styling.js.map